APT-CACHE(8)

NAZWA
apt-cache - odpytanie bufora APT

STRESZCZENIE

apt-cache [-agipns] [-o=opcja_konfiguracji] [-c=plik_konfiguracyjny] {gencaches | showpkg pakiet... | showsrc pakiet... | stats | dump | dumpavail | unmet | search wyr_regularne... | show pakiet [{=nr_wersji_pakietu | /wydanie_docelowe}]... | depends pakiet [{=nr_wersji_pakietu | /wydanie_docelowe}]... | rdepends pakiet [{=nr_wersji_pakietu | /wydanie_docelowe}]... | pkgnames [prefiks] | dotty pakiet [{=nr_wersji_pakietu | /wydanie_docelowe}]... | xvcg pakiet [{=nr_wersji_pakietu | /wydanie_docelowe}]... | policy [pakiet...] | madison pakiet... | {-v | --version} | {-h | --help}}

OPIS

apt-cache wykonuje różnorodne operacje na buforze (cache) pakietów programu APT. apt-cache nie zmienia stanu systemu, ale dostarcza mechanizmów przeszukiwania metadanych pakietów i generowania interesującego wyjścia.

Jedno z poniższych poleceń musi być użyte, chyba że została podana opcja -h albo --help.

gencaches
    gencaches tworzy bufor (cache) APT pakietów. Wywoływane jest automatycznie przez wszystkie polecenia potrzebujące bufora, jeśli nie istnieje lub jest przestarzały.

showpkg pakiet...
    showpkg wyświetla informacje na temat pakietów podanych w linii poleceń. Pozostałymi argumentami są nazwy pakietów. Wyświetlane są dostępne wersje oraz odwrotne zależności każdego z podanych pakietów, jak również zwykłe zależności dla każdej z wersji Normalne (zwykłe) zależności to są pakiety, od których dany pakiet zależy, odwrotne zależności stanowią te pakiety, które zależą od danego pakietu. Tak więc, pakiet musi spełniać normalne zależności, ale odwrotnych zależności - nie musi. Na przykład, apt-cache showpkg libreadline2 wypisze wyjście podobne do poniższego:

        Package: libreadline2
        Versions: 2.1-12(/var/state/apt/lists/foo_Packages),
        Reverse Depends:
          libreadlineg2,libreadline2
          libreadline2-altdev,libreadline2
        Dependencies:
        2.1-12 - libc5 (2 5.4.0-0) ncurses3.0 (0 (null))
        Provides:
        2.1-12 -
        Reverse Provides:
    Jak widać libreadline2 w wersji 2.1-12 zależy od libc5 i ncurses3.0, które muszą być zainstalowane, aby libreadline2 działała. Z kolei libreadlineg2 i libreadline2-altdev zależą od libreadline2. Jeżeli libreadline2 jest zainstalowany, to libc5 i ncurses3.0 (i ldso) muszą być także zainstalowane; natomiast libreadlineg2 oraz libreadline2-altdev nie muszą być zainstalowane. W celu zrozumienia, co oznaczają pozostałe linie, najlepiej przejrzeć kod źródłowy programu apt.

stats
    stats wyświetla statystyki dotyczące bufora pakietów. Nie wymaga żadnych argumentów. Wypisywane są następujące statystyki:

        • Całkowita liczba nazw pakietów (Total package names) - liczba nazw pakietów znajdujących się w buforze.

        • Zwykłe pakiety (Normal packages) jest to liczba zwykłych, regularnych nazw pakietów; są to pakiety, dla których istnieje relacja "jeden do jednego" między ich nazwami a nazwami używanymi przez inne pakiety jako zależności. Większość pakietów należy do tej kategorii.

        • Czyste pakiety wirtualne (Pure virtual packages) określa liczbę pakietów, które istnieją tylko jako nazwa pakietu wirtualnego; to jest pewne pakiety "dostarczają" tej nazwy wirtualnej, ale żaden pakiet nie używa tej nazwy. Na przykład "mail-transport-agent" w systemie Debian jest czystym pakietem wirtualnym; kilka pakietów dostarcza "mail-transport-agenta", ale żaden pakiet nie nazywa się "mail-transport-agent".

        • Pojedyncze pakiety wirtualne (Single virtual packages) - liczba pakietów, dla których istnieje tylko jeden pakiet, który dostarcza danego pakietu wirtualnego. Na przykład, w systemie Debian "X11-text-viewer" jest pakietem wirtualnym, ale tylko jeden pakiet, mianowicie "xless",dostarcza "X11-text-viewer".

        • Mieszane pakiety wirtualne (Mixed virtual packages) - liczba pakietów, które albo dostarczają poszczególnych pakietów wirtualnych, albo nazywają się tak, jak nazwa pakietu wirtualnego. Na przykład w systemie Debian "debconf" jest zarówno zwykłym pakietem, jak i jest pakietem dostarczanym przez pakiet "debconf-tiny".

        • Brakujące (Missing) jest liczbą nazw pakietów, do których odnoszą się jakieś zależności, ale które nie są spełnione przez żaden z dostępnych pakietów. Brakujące pakiety mogą być dowodem, że nie ma dostępu do całej dystrybucji albo że pakiet (rzeczywisty lub wirtualny) został usunięty z dystrybucji. Zazwyczaj odniesienia takie znajdują się w zależnościach typu "Conflicts" lub "Breaks".

        • Całkowita liczba różnych wersji (Total distinct versions) jest to liczba wersji pakietów znajdujących się w buforze, tak więc ta wartość jest co najmniej równa liczbie wszystkich nazw pakietów. Jeżeli pobierane są pakiety z więcej niż jednej dystrybucji (na przykład zarówno ze "stable", jak i z "unstable"), wartość ta może być znacznie większa niż liczba wszystkich nazw pakietów.

        • Całkowite zależności (Total dependencies) to liczba więzów zależności wymaganych przez wszystkie pakiety w buforze.

showsrc pakiet...
    showsrc wyświetla wszystkie pakiety źródłowe, które odpowiadają podanym nazwom pakietów. Wyświetlone zostaną wszystkie wersje tych pakietów oraz pakiety, których podana nazwa odpowiada nazwie pakietu binarnego.

dump
    dump pokazuje krótką listę wszystkich pakietów w buforze. Jest używany głównie w celu odpluskwiania.

dumpavail
    dumpavail wypisuje na standardowe wyjście (stdout) listę dostępnych pakietów. Jest to polecenie odpowiednie do użycia z programem dpkg(1) i jest używane w metodzie dselect(1) tego programu.

unmet
    unmet pokazuje podsumowanie wszystkich niespełnionych zależności w buforze pakietów

show pakiet...
    show spełnia funkcje podobne do dpkg --print-avail; pokazuje szczegółowe informacje o podanych pakietach.

search wyr_regularne...
    search wykonuje pełne wyszukiwanie podanego wzorca będącego wyrażeniem regularnym POSIX (patrz regex(7)) we wszystkich dostępnych listach pakietów. Przeszukuje nazwy pakietów (w tym pakietów wirtualnych) i ich szczegółowe (długie) opisy, szukając w nich podanego wyrażenia regularnego i wypisuje nazwę pakietu i jego krótki opis. Jeżeli podana jest opcja --full, to wtedy dla każdego znalezionego pakietu informacje na wyjściu są podobne do tego, co pokazuje polecenie show. Jeżeli podano opcję --names-only, to są przeszukiwane tylko nazwy pakietów, bez ich długich opisów.

    Oddzielne argumenty mogą być używane do podania kilku wzorców, które będą traktowane jakby były połączone spójnikiem logicznym "i".

depends pakiet...
    depends wyświetla listę wszystkich zależności danego pakietu i wszystkie możliwe pakiety, które mogą spełnić te zależności.

rdepends pakiet...
    rdepends pokazuje listę wszystkich odwrotnych zależności danego pakietu.

pkgnames [prefiks]
    To polecenie wyświetla nazwy wszystkich pakietów znanych systemowi APT. Opcjonalnym argumentem jest przedrostek nazwy pakietów. Wynik jest odpowiedni do użycia z funkcją powłoki (shella) uzupełniania nazw za pomocą klawisza tabulacji i jest wypisywany bardzo szybko. Tego polecenia najlepiej używać z opcją --generate.

    Proszę zauważyć, że to, iż pakiet jest znany systemowi APT, niekoniecznie oznacza, że jest dostępny do pobrania i zainstalowania albo zainstalowany. Może być np. pakietem wirtualnym, które także są wypisane w wygenerowanej liście.

dotty pakiet...
    dotty bierze jako argument listę pakietów i generuje wyjście odpowiednie dla programu dotty z pakietu GraphViz[1]. Wynikiem będzie zbiór wierzchołków i krawędzi reprezentujących powiązania między pakietami. Domyślnie podane pakiety wyśledzą wszystkie pakiety zależne. Może to spowodować wypisanie bardzo dużego grafu. Aby wypisać powiązania tylko pomiędzy pakietami podanymi w linii poleceń, należy użyć opcji APT::Cache::GivenOnly.

    Wynikowe wierzchołki będą miały różnorakie kształty: zwykłe pakiety są prostokątami, czyste pakiety wirtualne to trójkąty, mieszane pakiety wirtualne są rombami, sześciokąty oznaczają brakujące pakiety . Pomarańczowe prostokąty oznaczają koniec rekurencji (liście), niebieskie linie to pre-zależności, linie zielone to konflikty.

    Uwaga: dotty nie potrafi narysować większego zbioru pakietów.

xvcg pakiet...
    Robi to samo, co dotty, tylko dla xvcg z narzędzia VCG[2].

policy [pakiet...]
    policy jest pomyślane w celu debugowania zagadnień związanych z plikiem preferencji. Jeżeli nie podano żadnych opcji, wypisane zostaną informacje o priorytecie każdego źródła. W przeciwnym wypadku, wypisuje szczegółowe informacje o priorytecie danego pakietu.

madison pakiet...
    polecenie madison z apt-cache próbuje naśladować format wyjścia i część funkcjonalności programu madison - narzędzia zarządzania archiwum Debiana. Wyświetla dostępne wersje pakietów w formacie tabeli. W przeciwieństwie do oryginału, może wyświetlić informacje tylko dla tych architektur, dla których APT pobrało listy pakietów (APT::Architecture).

OPCJE

Wszystkie opcje linii poleceń mogą być ustawione w pliku konfiguracyjnym. Poniższe opisy wskazują, którą opcję w pliku konfiguracyjnym należy ustawić. W przypadku opcji logicznych, można unieważnić ustawienia pliku konfiguracyjnego, używając -f-, --no-f, -f=no albo czegoś podobnego.

-p, --pkg-cache
    Podaje nazwę pliku to przechowywania bufora pakietów, który jest podstawowym buforem używanym we wszystkich operacjach. Pozycja w pliku konfiguracyjnym: Dir::Cache::pkgcache.

-s, --src-cache
    Podaje nazwę pliku to przechowywania bufora źródeł. Jest używany tylko przez akcję gencaches i przechowuje sparsowaną wersję informacji o pakietach pobraną ze zdalnych źródeł. Podczas budowania bufora pakietów, bufor źródeł jest używany w celu uniknięcia ponownego parsowania wszystkich plików pakietów. Pozycja w pliku konfiguracyjnym: Dir::Cache::srcpkgcache.

-q, --quiet
    Cichy; wypisuje tylko informacje potrzebne do logowania, opuszczając wskaźniki postępu. Więcej znaków q spowoduje jeszcze bardziej ciche wyjście, maksimum jest 2. Można także ustawić poziom cichości za pomocą -q=#,nadpisując tym samym opcję z pliku konfiguracyjnego. Pozycja w pliku konfiguracyjnym: quiet.

-i, --important
    Wyświetla tylko ważne zależności; do używania z akcjami unmet o depends. Powoduje wypisanie tylko zależności typu Depends i Pre-Depends. Pozycja w pliku konfiguracyjnym: APT::Cache::Important.

--no-pre-depends, --no-depends, --no-recommends, --no-suggests, --no-conflicts, --no-breaks, --no-replaces, --no-enhances
    Domyślnie depends i rdepends wypisują wszystkie zależności. Można to zmienić, używając tych flag, które spowodują pominięcie podanych typów zależności. Pozycja w pliku konfiguracyjnym: APT::Cache::ShowTypZależności, na przykład APT::Cache::ShowRecommends.

-f, --full
    Podczas szukania wypisuj pełną informację o pakiecie. Pozycja w pliku konfiguracyjnym: APT::Cache::ShowFull.

-a, --all-versions
    Akcja show wypisuje wszystkie rekordy dla wszystkich dostępnych wersji. Jest to opcja domyślna, aby ją wyłączyć, proszę użyć --no-all-versions. Jeżeli podano --no-all-versions, to będzie wyświetlana tylko wersja-kandydat (czyli ta, która byłaby wybrana do instalacji). Ta opcja ma znaczenie tylko dla polecenia show. Pozycja w pliku konfiguracyjnym: APT::Cache::AllVersions.

-g, --generate
    Automatycznie odbudowuje bufor pakietów, zamiast używać istniejącego bufora. Ta opcja jest domyślnie włączona, aby ją wyłączyć, należy użyć --no-generate. Pozycja w pliku konfiguracyjnym: APT::Cache::Generate.

--names-only, -n
    Przeszukaj tylko nazwy pakietów, pomijając szczegółowe opisy. Pozycja w pliku konfiguracyjnym: APT::Cache::NamesOnly.

--all-names
    Powoduje, że akcja pkgnames wypisze nazwy wszystkich pakietów, łącznie z pakietami wirtualnymi oraz pakietami mającymi brakujące zależności. Pozycja w pliku konfiguracyjnym: APT::Cache::AllNames.

--recurse
    Powoduje, że zależności w poleceniach depends i rdepends będą zależnościami rekurencyjnymi, tak że wszystkie wymienione pakiety zostaną wypisane tylko raz. Pozycja w pliku konfiguracyjnym: APT::Cache::RecurseDepends.

--installed
    Ogranicza wyjście poleceń depends i rdepends tylko do pakietów, które są obecnie zainstalowane. Pozycja w pliku konfiguracyjnym: APT::Cache::Installed.

-h, --help
    Wyświetla krótkie informacje o użyciu.

-v, --version
    Wyświetla wersję programu.

-c, --config-file
    Plik konfiguracyjny. Podaje plik konfiguracyjny do użycia. Program najpierw przeczyta swój domyślny plik konfiguracyjny, a następnie plik podany jako argument tej opcji. Jeśli jest potrzeba ustawienia opcji konfiguracji zanim domyślny plik konfiguracyjny zostanie przetworzony, należy podać plik do użycia w zmiennej środowiskowej APT_CONFIG. Informacje o składni pliku można znaleźć w apt.conf(5).

-o, --option
    Ustawia opcję konfiguracji. Pozwala ustawić dowolną opcję konfiguracji. Składnia jest następująca: -o Foo::Bar=bar. -o i --option można podać wielokrotnie - do ustawiania różnych opcji.

PLIKI

/etc/apt/sources.list
    Lokalizacje, z których będą ściągane pakiety. Pozycja w pliku konfiguracyjnym: Dir::Etc::SourceList.

/etc/apt/sources.list.d/
    Części pliku zawierającego lokalizacje, z której są pobierane pakiety. Pozycja w pliku konfiguracyjnym: Dir::Etc::SourceParts.

/var/lib/apt/lists/
    Składnica zawierająca informacje o każdym zasobie pakietów podanym w sources.list(5) Pozycja w pliku konfiguracyjnym: Dir::State::Lists.

/var/lib/apt/lists/partial/
    Składnica obecnie pobieranych informacji o stanie pakietów. Pozycja w pliku konfiguracyjnym: Dir::State::Lists (partial zostanie dodane automatycznie)

ZOBACZ TAKŻE

apt.conf(5), sources.list(5), apt-get(8)

DIAGNOSTYKA

apt-cache zwraca zero, gdy zakończyło się pomyślnie, 100 - w przypadku błędu.

BUGS

Strona błędów APT[3]. Aby zgłosić błąd w APT, proszę przeczytać /usr/share/doc/debian/bug-reporting.txt lub opis polecenia reportbug(1).

TŁUMACZENIE

Tłumaczenie stron podręcznika: Robert Luberda <robert@debian.org>, 2000-2012. Tłumaczenie przewodnika offline: Krzysztof Fiertek <akfedux@megapolis.pl>, 2004

Proszę zauważyć, że przetłumaczony dokument może zawierać fragmenty nieprzetłumaczone. Ma to na celu uniknięcie utracenia istotnych informacji, w przypadkach gdy oryginał zostanie zaktualizowany, a tłumaczenie - nie.

AUTORZY

Jason Gunthorpe

zespół APT

PRZYPISY

1.  GraphViz
    http://www.research.att.com/sw/tools/graphviz/

2.  narzędzia VCG
    http://rw4.cs.uni-sb.de/users/sander/html/gsvcg1.html

3.  Strona błędów APT
    http://bugs.debian.org/src:apt